import javax.naming.*;
import javax.naming.directory.*;

import java.util.Hashtable;

/**
 * Demonstrates how to read a binary attribute using the "binary" option.
 *
 * usage: java ReadBinary
 */
class ReadBinary {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Use ';binary' option
	    Attributes attrs = ctx.getAttributes("cn=S. User, ou=NewHires",
		//		new String[]{"mySpecialKey;binary"});
		new String[]{"jpegphoto"});

	    // See what we got
	    Attribute attr = attrs.get("mySpecialKey;binary");
	    if (attr != null) {
		Object val = attr.get();
		if (val instanceof String) {
		    System.out.println(val);
		} else {
		    byte[] buf = (byte[])val;
		    for (int i = 0; i < buf.length; i++) {
			System.out.println(Integer.toHexString(buf[i]));
		    }
		}
	    }
	    // do something useful with ctx
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
