import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to delete a referral entry.
  *
  * usage: java DeleteReferral
  */
class DeleteReferral {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:489/o=JNDITutorial");

	// Set referral property; optional because "ignore" is the default
	env.put(Context.REFERRAL, "ignore");

	// Uncomment this line when using 1.0.1 
	// env.put("java.naming.ldap.control.manageReferral", "true");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Remove entry
	    ctx.destroySubcontext("cn=NewReferral");

	} catch (NamingException e) {
	    System.out.println("Deletion failed: " + e);
	}
    }
}
