import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to look up an attribute definition's schema given its name.
  *
  * usage: java LookupAttributeDefn
  */
class LookupAttributeDefn {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("");

	    // Get schema object for "cn"
	    DirContext cnSchema = (DirContext)schema.lookup("AttributeDefinition/cn");

	    // Get "cn" object's attributes
	    Attributes cnAttrs = cnSchema.getAttributes("");

	    System.out.println(cnAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
